# (C) 2001-2021 Intel Corporation. All rights reserved.
# Your use of Intel Corporation's design tools, logic functions and other 
# software and tools, and its AMPP partner logic functions, and any output 
# files from any of the foregoing (including device programming or simulation 
# files), and any associated documentation or information are expressly subject 
# to the terms and conditions of the Intel Program License Subscription 
# Agreement, Intel FPGA IP License Agreement, or other applicable 
# license agreement, including, without limitation, that your use is for the 
# sole purpose of programming logic devices manufactured by Intel and sold by 
# Intel or its authorized distributors.  Please refer to the applicable 
# agreement for further details.


source [file join [file dirname [info script]] "altera/sval_top/main_100G.tcl"]
source [file join [file dirname [info script]] "altera/sval_top/main_misc.tcl"]
 
# Function to run a simple series of tests
 
proc run_test_without_loopback {} {
    for {set inst_num 0} {$inst_num < $::INSTANCE_NUM} {incr inst_num} {
        # obtain ip inst base addr offset
        set ip_inst_base_addr [format 0x%X [expr $inst_num << 24]]
 
        puts "--- Turning off packet generation ----"
        puts "--------------------------------------\n"
        stop_pkt_gen $ip_inst_base_addr
 
        #puts "--------- Enabling loopback ----------"
        #puts "--------------------------------------\n"
        #loop_on
 
        puts "--- Wait for RX clock to settle... ---"
        puts "--------------------------------------\n"
        sleep 2
 
        puts "-------- Printing PHY status ---------"
        puts "--------------------------------------\n"
        chkphy_status $ip_inst_base_addr
 
        puts "---- Clearing MAC stats counters -----"
        puts "--------------------------------------\n"
        clear_all_stats $ip_inst_base_addr
	
        puts "--- Initialize PKT ROM Read address for IP_INST\[$inst_num\]----"
        puts "--------------------------------------\n"
        init_packet_rom "100G" $ip_inst_base_addr
 
        puts "--------- Sending packets... ---------"
        puts "--------------------------------------\n"
        start_pkt_gen $ip_inst_base_addr
        sleep 1
        stop_pkt_gen $ip_inst_base_addr
 
        puts "----- Reading MAC stats counters -----"
        puts "--------------------------------------\n"
        chkmac_stats $ip_inst_base_addr
        
        puts "---------------- Done ----------------\n"
    } 
}

proc run_test {} {
    global XCVR_TYPE_GUI
    global LANE_NUM

    for {set inst_num 0} {$inst_num < $::INSTANCE_NUM} {incr inst_num} {
        # obtain ip inst base addr offset
        set ip_inst_base_addr [format 0x%X [expr $inst_num << 24]]
 
        puts "--- Turning off packet generation ----"
        puts "--------------------------------------\n"
        stop_pkt_gen $ip_inst_base_addr
 
        puts "--------- Enabling loopback ----------"
	puts "--------------------------------------\n"
	if {$XCVR_TYPE_GUI==0} {
   	    internal_loop_back_ux $LANE_NUM 3 2
	} elseif {$XCVR_TYPE_GUI==1} {
	    internal_loop_back_bk $LANE_NUM 
	}
 
        puts "--- Wait for RX clock to settle... ---"
        puts "--------------------------------------\n"
        sleep 2
 
        puts "-------- Printing PHY status ---------"
        puts "--------------------------------------\n"
        chkphy_status $ip_inst_base_addr
 
        puts "---- Clearing MAC stats counters -----"
        puts "--------------------------------------\n"
        clear_all_stats $ip_inst_base_addr
	
        puts "--- Initialize PKT ROM Read address for IP_INST\[$inst_num\]----"
        puts "--------------------------------------\n"
        init_packet_rom "100G" $ip_inst_base_addr
 
        puts "--------- Sending packets... ---------"
        puts "--------------------------------------\n"
        start_pkt_gen $ip_inst_base_addr
        sleep 1
        stop_pkt_gen $ip_inst_base_addr

        puts "----- Reading MAC stats counters -----"
        puts "--------------------------------------\n"
        chkmac_stats $ip_inst_base_addr
        
        puts "---------------- Done ----------------\n"
    } 
}


